from math import *
from random import *
from matplotlib.pyplot import *

#Partie I
# exercice 1
def tarif(n):
    if n<=20 :
        return(0.1*n)
    elif n<=40:
        return (2+(n-20)*0.08)
    else :
        return(3.6+(n-40)*0.06)

# exercice 2
def mention(n):
    if n<10:
        rep="Non reçu"
    elif n<12:
        rep="passable"
    elif n<14:
        rep="Assez Bien"
    elif n<16:
        rep="Bien"
    elif n<18:
        rep="Très Bien"
    else:
        rep="Très Bien avec félicitations du jury"
    return(rep)

# exercice 4
def somme(s):
    compteur=0
    for i in range(1,7):
        for j in range (1,7):
            for k in range(1,7):
                if i+j+k==s:
                    compteur=compteur+1
    return compteur

# exercice 5
def depasse(seuil):
    n=0
    u=800
    while u<seuil:
        u=3/4*u+330
        n=n+1
    return n

#Partie II
# exercice 9.2
def dernier(L):
    n=len(L)
    return L[n-1]

# exercice 10.3
def pair(n):
    if n%2==0:
        return True
    else :
        return False


#Partie III
# exercice 11.1
def distanceCoordonnees(xA,yA,xB,yB):
    return sqrt((xB-xA)**2+(yB-yA)**2)


# exercice 11.2
def distance(A,B):
    return sqrt((B[0]-A[0])**2+(B[1]-A[1])**2)


# exercice 11.3
#Malheureusement la fonction ci-dessous bugue (problèmes d'arrondis)
def RectangleEnPremierSommetnemarchepas(A,B,C):
    if distance(A,B)**2+distance(A,C)**2==distance(B,C)**2:
        return(True)
    else:
        return(False)
#Correction avec "approximation"
def quasiegalite(a,b):
    if abs(a-b)<1E-10:
        return True
    else:
        return False



def RectangleEnPremierSommet(A,B,C):
    if quasiegalite(distance(A,B)**2+distance(A,C)**2,distance(B,C)**2):
        return(True)
    else:
        return(False)


# exercice 11.5.d.
def Rectangle(A,B,C):
    return RectangleEnPremierSommet(A,B,C) or RectangleEnPremierSommet(B,A,C) or RectangleEnPremierSommet(C,B,A)

#exercice 12
def milieu(A,B):
    x=(A[0]+B[0])/2
    y=(A[1]+B[1])/2
    return [x,y]

def TestParallelogramme(A,B,C,D):
    I=milieu(A,C)
    J=milieu(B,D)
    if I==J :
        return True
    else:
        return False

#Partie IV
#Exercice 13.1 à 13.4
def SommeDiv(n):
    somme=0
    for i in range(1,n):
        if n%i==0:
            somme=somme+i
    return(somme)


def EstParfait(n):
    if n==SommeDiv(n):
        return True
    else :
        return False


def EstPremier(n):
    if SommeDiv(n)==1:
        return True
    else :
        return False


def EstChanceux(n):
    chanceux=True
    for x in range(n-1):
        chanceux=chanceux and EstPremier(x**2+x+n)
    return chanceux

#Exercice 13.5
def liste_parfaits(n):
    liste=[]
    for i in range(2,n+1):
        if EstParfait(i) :
            liste=liste+[i]
    return liste

def liste_chanceux(n):
    liste=[]
    for i in range(2,n+1):
        if EstChanceux(i) :
            liste=liste+[i]
    return liste

#Exercice 14
def marche():
    position=0
    for i in range(4):
        sens=randint(0,1)
        if sens==0:
            position=position-1
        else:
            position=position+1
    return position

def simulation(n):
    liste=[]
    for i in range(0,n):
        liste=liste+[marche()]
    return liste

def histogramme(n):
    hist(simulation(n),bins=[-4,-3,-2,-1,0,1,2,3,4])
    show()

#Présentation avec diagramme batons
def diagrammebatons(n):
    hist(simulation(n),bins=range(-4,6),align='left',edgecolor = 'black')
    show()



def frequence(n):
    listedesfrequences=[]
    listedespositions=simulation(n)
    for i in range(-4,5):
        frequence=listedespositions.count(i)/n
        listedesfrequences=listedesfrequences+['position '+str(i)+' : '+str(frequence)]
    return listedesfrequences


#Exercice supplémentaire Calcul de médiane
def mediane(L):
    L=sorted(L)
    n=len(L)
    if pair(n):
        a=L[n//2-1]
        b=L[n//2]
        return(a+b)/2
    else:
        return L[(n+1)//2-1]









































